/* (C) 2005-2006 by Marcin Wiacek www.mwiacek.com */

#include "../../../../cfg/config.h" //msvc2005
#include "../../../protocol/gsmprot.h"
#include "../../../misc/coding/coding.h"
#include "../ndct34.h"
#include "n6510.h"

/* -------------------------------- series 40 3.0 -------------------------- */

GSM_Error GSM_Phone_N6510::GetSMSFolders2(GSM_SMSFolders *Folders)
{
	GSM_FileFolderInfoList		List;
	GSM_FileFolderInfoListSubEntry  *SubEntry;
	GSM_Error			error;

	List.Info.SetID(StringToUnicodeReturn("d:\\predefmessages"));

	error = GetFolderInfoList(&List);
	if (error.Code != GSM_ERR_NONE && error.Code != GSM_ERR_FOLDER_PART) return error;

	SubEntry = NULL;
	while (List.GetNext(&SubEntry) == TRUE) {		
		if (strstr(UnicodeToStringReturn(SubEntry->Info.GetName()),"predef")!=NULL) {
			continue;
		} else if (!strcmp(UnicodeToStringReturn(SubEntry->Info.GetName()),"exchange")) {
			continue;
		}

		if (!strcmp(UnicodeToStringReturn(SubEntry->Info.GetName()),"1")) {
			Folders->Add(StringToUnicodeReturn("Inbox"),TRUE,MEM_PHONE);
		} else if (!strcmp(UnicodeToStringReturn(SubEntry->Info.GetName()),"3")) {
			Folders->Add(StringToUnicodeReturn("Sent items"),FALSE,MEM_PHONE);
		} else if (!strcmp(UnicodeToStringReturn(SubEntry->Info.GetName()),"4")) {
			Folders->Add(StringToUnicodeReturn("Saved messages"),FALSE,MEM_PHONE);
		} else if (!strcmp(UnicodeToStringReturn(SubEntry->Info.GetName()),"5")) {
			Folders->Add(StringToUnicodeReturn("Drafts"),FALSE,MEM_PHONE);
		} else if (!strcmp(UnicodeToStringReturn(SubEntry->Info.GetName()),"6")) {
			Folders->Add(StringToUnicodeReturn("Templates"),FALSE,MEM_PHONE);
		} else {
			Folders->Add(SubEntry->Info.GetName(),FALSE,MEM_PHONE);
		}
	}

        return GSM_Return_Error(GSM_ERR_NONE);
}

GSM_Error GSM_Phone_N6510::GetSMS2(GSM_SMSList *List, GSM_File *File)
{
	unsigned int 	i = 176, start = 176, j;
	GSM_SMSEntry 	*SMS;
	double		g;
	wchar_t		ala=0x00;
	BOOLEAN		first=TRUE;

	SMS = new (GSM_SMSEntry);

	List->ClearAll();
	List->SetName(&ala);

	(*Debug)->Deb("sms file %02x\n",File->Buffer.data()[start]);
	SMS->SetPhoneNumber(NokiaGetUnicodeString(File->Buffer.data()+94));
	switch (File->Buffer.data()[start]) {
	case 0x00:
	case 0x04:
	case 0x11:
	case 0x20:
	case 0x24:
		if(File->Buffer.data()[start]==0x11) {
			i+=15;
			SMS->firstbyte = 1; //fixme
			SMS->TPDCS=File->Buffer.data()[i];
			i+=2;
		} else {
			SMS->firstbyte = File->Buffer.data()[i];
			//semioctets to chars in phone number
			j = File->Buffer.data()[i+1];
			if (j % 2) j++;
			i+=(j / 2 + 1);
			SMS->TPDCS=File->Buffer.data()[i+3];
			i+=11;
		}

		j = File->Buffer.data()[i];
		SMS->TPUDL = j;
		if (SMS->GetCoding() == SMS_Coding_Default_No_Compression) {
			//we need to find, if part of byte was used or not
			g = ((double)j*7/8) - (unsigned int)((j*7/8));
			j = j*7/8;
			if (g != 0.0) j++;
		}
		SMS->UserData.append((const unsigned char *)(File->Buffer.data()+i+1),j);
		i+=j;
		i+=11;
		SMS->SetSMSCNumber(StringToUnicodeReturn((char *)(File->Buffer.data()+i)));
		j=strlen((const char *)(File->Buffer.data()+i));
		i+=j+4;
		List->SetName(NokiaGetUnicodeString(File->Buffer.data()+i));
		break;
	case 0x31:
	case 0x51:
	case 0x71:
		if(File->Buffer.data()[start]!=0x31) SMS->firstbyte = File->Buffer.data()[i];
		if (UnicodeLength(NokiaGetUnicodeString(File->Buffer.data()+94)) == 0x00) {
			//semioctets to chars in phone number
			j = File->Buffer.data()[i+2];
			if (j % 2) j++;
			i+=(j/2 + 1) + 4;
		} else {
			i+=15;
		}
		if(File->Buffer.data()[start]==0x31) SMS->firstbyte = 1; //fixme
		SMS->TPDCS=File->Buffer.data()[i];
		i+=2;

		j = File->Buffer.data()[i];
		SMS->TPUDL = j;
		if (SMS->GetCoding() == SMS_Coding_Default_No_Compression) {
			//we need to find, if part of byte was used or not
			g = ((double)j*7/8) - (unsigned int)((j*7/8));
			j = j*7/8;
			if (g != 0.0) j++;
		}
		SMS->UserData.append((const unsigned char *)File->Buffer.data()+i+1,j);
		i+=j;
		i+=11;

		if(File->Buffer.data()[start]!=0x71 && i<File->Buffer.size()) {
			List->SetName(NokiaGetUnicodeString(File->Buffer.data()+i));

			if (UnicodeLength(NokiaGetUnicodeString(File->Buffer.data()+94)) == 0x00) {
				i+=UnicodeLength(List->GetName())*2+5;
				while (true) {
					if (File->Buffer.data()[i+1]==0x00) break;
					if (first) {
						SMS->SetPhoneNumber(NokiaGetUnicodeString(File->Buffer.data()+i));
						i+=UnicodeLength(NokiaGetUnicodeString(File->Buffer.data()+i))*2+13;
					} else {
//						CopyUnicodeString(sms->SMS[0].OtherNumbers[sms->SMS[0].OtherNumbersNum],FFF.Buffer+i);
						i+=UnicodeLength(NokiaGetUnicodeString(File->Buffer.data()+i))*2+13;
					}
					break;
				}
			}
		}
		break;
	case 0x44:
	case 0x40://40 without name
	case 0x64://64 without name
		SMS->firstbyte = File->Buffer.data()[i];

		//semioctets to chars in phone number
		j = File->Buffer.data()[i+1];
		if (j % 2) j++;
		i+=(j / 2 + 1);

		SMS->TPDCS=File->Buffer.data()[i+2];

		j = File->Buffer.data()[i+11];
		SMS->TPUDL = j;
		SMS->UserData.append((const unsigned char *)File->Buffer.data()+i+12,j);

		if (File->Buffer.data()[start]!=0x64) {
			i+=j;
			SMS->SetSMSCNumber(StringToUnicodeReturn((char *)(File->Buffer.data()+i+2)));
		}
		break;
	default:
	        return GSM_Return_Error(GSM_ERR_UNKNOWN);
	}

	SMS->SetDateTime(&File->Info.ModificationDateTime);

	List->ID2.clear();
	List->ID2.append((const wchar_t *)File->Info.GetID(),UnicodeLength(File->Info.GetID()));
	List->Memory 	= MEM_PHONE;
	List->Icon 	= SMS_Read;
	List->Add(SMS);

        return GSM_Return_Error(GSM_ERR_NONE);
}

GSM_Error GSM_Phone_N6510::GetNextSMS2(GSM_SMSList *List, BOOLEAN start)
{
	GSM_Error	error;
	BOOLEAN		ReadFolder = TRUE;
	GSM_File 	File;

	if (start) {
		SMSFoldersList.Info.SetID(StringToUnicodeReturn("d:\\predefmessages"));

		error = GetFolderInfoList(&SMSFoldersList);
		if (error.Code != GSM_ERR_NONE && error.Code != GSM_ERR_FOLDER_PART) return error;

		SMSFoldersSubEntry 	= NULL;
		ReadFolder 		= FALSE;
		SMSFolderNum 		= 0;
	}
	while (1) {
		//getting next file from folder
		if (ReadFolder && SMSList.GetNext(&SMSSubEntry)) {
			File.Info.SetID(SMSSubEntry->Info.GetID());
			File.Buffer.clear();

			while (true) {
				error = GetFilePart2(&File);				
				if (error.Code != GSM_ERR_NONE) return error;

				//we skip MMS files
				if (File.Buffer.size()>5 && File.Buffer.data()[6] != 0x00) {
					if (File.Info.Size != File.Buffer.size()) {
						error = CloseFile2(&File);
						if (error.Code != GSM_ERR_NONE) return error;
					}
					break;
				}

				//full SMS file
				if (SMSSubEntry->Info.Size == File.Buffer.size()) {
					memcpy(&File.Info.ModificationDateTime,&SMSSubEntry->Info.ModificationDateTime,sizeof(GSM_DateTime));
					List->Folder2 = SMSFolderNum;
					return GetSMS2(List,&File);
				}
			}
			continue;
		}
		//getting next folder
		while (1) {
			if (!SMSFoldersList.GetNext(&SMSFoldersSubEntry)) return GSM_Return_Error(GSM_ERR_EMPTY);
			if (strstr(UnicodeToStringReturn(SMSFoldersSubEntry->Info.GetName()),"predef")!=NULL) {
				continue;
			} else if (!strcmp(UnicodeToStringReturn(SMSFoldersSubEntry->Info.GetName()),"exchange")) {
				continue;
			}
			break;
		}
		//reading files from folder
		SMSList.Info.SetID(SMSFoldersSubEntry->Info.GetID());
		(*Debug)->Deb("getting content of folder %s\n",UnicodeToStringReturn(SMSFoldersSubEntry->Info.GetID()));

		SMSFolderNum++;

		error = GetFolderInfoList(&SMSList);
		if (error.Code == GSM_ERR_EMPTY) {
			ReadFolder = FALSE;
			continue;
		}
		if (error.Code != GSM_ERR_NONE && error.Code != GSM_ERR_FOLDER_PART) return error;

		SMSSubEntry = NULL;
		ReadFolder = TRUE;
	}
}

GSM_Error GSM_Phone_N6510::DeleteSMS2(GSM_SMSList *List)
{
	return DeleteFile((wchar_t *)List->ID2.data());
}

/* -------------------------------- series 40 1.0 & 2.0 -------------------- */

GSM_Error GSM_Phone_N6510::ReplyGetSMSFolders1(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	GSM_SMSFolders 		*Folders = (GSM_SMSFolders *)S;
	unsigned int		i, current = 6, num = 0;
	GSM_SMSFoldersSubEntry  *SubFolder;

	(*Debug)->Deb("RECEIVED: SMS folders\n");
	for (i=0;i<msg->Buffer.data()[5];i++) {
		while (true) {
			if (msg->Buffer.data()[current]   == msg->Buffer.data()[6] &&
			    msg->Buffer.data()[current+1] == msg->Buffer.data()[7]) break;
			if (current+4 > msg->Buffer.size()) return GSM_Return_Error(GSM_ERR_UNKNOWN);
			current++;
		}
		current+=4;
		switch (num) {
		case 0x00:
			Folders->Add(NokiaGetUnicodeString(msg->Buffer.data()+current),TRUE,MEM_SIM);
			num++;
			break;
		case 0x01:
			Folders->Add(NokiaGetUnicodeString(msg->Buffer.data()+current),FALSE,MEM_SIM);
			num++;
			SubFolder = NULL;
			Folders->GetNext(&SubFolder);
			Folders->Add(SubFolder->GetName(),TRUE,MEM_PHONE);
			num++;
			Folders->Add(NokiaGetUnicodeString(msg->Buffer.data()+current),FALSE,MEM_PHONE);
			num++;
			break;
		default:
			Folders->Add(NokiaGetUnicodeString(msg->Buffer.data()+current),FALSE,MEM_PHONE);
			num++;
		}
	}
	return GSM_Return_Error(GSM_ERR_NONE);
}

GSM_Error GSM_Phone_N6510::GetSMSFolders1(GSM_SMSFolders *Folders)
{
	unsigned char Buff[] = {NOKIA_FRAME1, 0x12, 0x00, 0x00};

	(*Debug)->Deb("SENT: getting SMS folders\n");
	return Write(Buff, sizeof(Buff), 0x14, 4, ID_GetSMSFolders+ID, Folders);
}

GSM_Error GSM_Phone_N6510::ReplyGetSMSStatus1(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	GSM_SMSStatus *Status = (GSM_SMSStatus *)S;

	(*Debug)->Deb("RECEIVED: SMS status\n");

	switch (msg->Buffer.data()[3]) {
	case 0x09:
		(*Debug)->Deb("  Phone size   : %i\n",msg->Buffer.data()[10]*256+msg->Buffer.data()[11]);
		(*Debug)->Deb("  Phone used   : %i\n",msg->Buffer.data()[12]*256+msg->Buffer.data()[13]);
		(*Debug)->Deb("  Phone unRead : %i\n",msg->Buffer.data()[14]*256+msg->Buffer.data()[15]);
		(*Debug)->Deb("  SIM size   : %i\n",msg->Buffer.data()[22]*256+msg->Buffer.data()[23]);
		(*Debug)->Deb("  SIM used   : %i\n",msg->Buffer.data()[24]*256+msg->Buffer.data()[25]);
		(*Debug)->Deb("  SIM unRead : %i\n",msg->Buffer.data()[26]*256+msg->Buffer.data()[27]);

		if (Status->Memory==MEM_SIM) {
			Status->SMSUnRead = msg->Buffer.data()[26]*256+msg->Buffer.data()[27];
			Status->SMSFree   = msg->Buffer.data()[22]*256+msg->Buffer.data()[23]-(msg->Buffer.data()[24]*256+msg->Buffer.data()[25]);
			Status->SMSRead   = msg->Buffer.data()[22]*256+msg->Buffer.data()[23]-Status->SMSFree-Status->SMSUnRead;
		} else {
			Status->SMSUnRead = msg->Buffer.data()[14]*256+msg->Buffer.data()[15];
			Status->SMSFree   = msg->Buffer.data()[10]*256+msg->Buffer.data()[11]-(msg->Buffer.data()[12]*256+msg->Buffer.data()[13]);
			Status->SMSRead   = msg->Buffer.data()[10]*256+msg->Buffer.data()[11]-Status->SMSFree-Status->SMSUnRead;
		}
	
		return GSM_Return_Error(GSM_ERR_NONE);
	default:
	        return GSM_Return_Error(GSM_ERR_UNKNOWN);
	}
}

GSM_Error GSM_Phone_N6510::GetSMSStatus1(GSM_SMSStatus *Status)
{
	GSM_Error	error;
	unsigned char 	Buff[] = {NOKIA_FRAME1, 0x08, 0x00, 0x00};
	GSM_SMS_Loc 	SMSLocations;

	if (Status->Memory!=MEM_SIM && Status->Memory!=MEM_PHONE) {
		return GSM_Return_Error(GSM_ERR_NOT_SUPPORTED);
	}

	(*Debug)->Deb("SENT: getting status for SMS\n");
	error = Write(Buff, sizeof(Buff), 0x14, 4, ID_GetSMSStatus+ID, Status);
	if (error.Code != GSM_ERR_NONE || Status->Memory==MEM_SIM) return error;

	//status of Templates folder
	SMSLocations.FolderID = 0x06;
	error = GetSMSFolderStatus1(&SMSLocations);
	if (error.Code != GSM_ERR_NONE) return error;

	Status->SMSTemplates = SMSLocations.Locations.size();

	return GSM_Return_Error(GSM_ERR_NONE);
}

GSM_Error GSM_Phone_N6510::ReplyGetSMSFolderStatus1(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	int		i, last = 0;
	GSM_SMS_Loc 	*SMSLocations = (GSM_SMS_Loc *)S;
	unsignedint	s2;

	(*Debug)->Deb("RECEIVED: SMS folder status received\n");

	(*Debug)->Deb("  locations ");
	for (i=0;i<msg->Buffer.data()[6]*256+msg->Buffer.data()[7];i++) {
		(*Debug)->Deb("%i ",msg->Buffer.data()[8+(i*2)]*256+msg->Buffer.data()[(i*2)+9]);
		if (msg->Buffer.data()[8+(i*2)]*256+msg->Buffer.data()[(i*2)+9] < last) {
			//pushing int on front
			s2.clear();
			SMSLocations->Locations.swap(s2);
			SMSLocations->Locations.push_back(msg->Buffer.data()[8+(i*2)]*256+msg->Buffer.data()[(i*2)+9]);
			SMSLocations->Locations.append(s2);
		} else {
			SMSLocations->Locations.push_back(msg->Buffer.data()[8+(i*2)]*256+msg->Buffer.data()[(i*2)+9]);
		}
		last = msg->Buffer.data()[8+(i*2)]*256+msg->Buffer.data()[(i*2)+9];
	}
	(*Debug)->Deb("\n");

	(*Debug)->Deb("  locations ");
	for (i=0;i<msg->Buffer.data()[6]*256+msg->Buffer.data()[7];i++) {
		(*Debug)->Deb("%i ",SMSLocations->Locations.data()[i]);
	}
	(*Debug)->Deb("\n");

	return GSM_Return_Error(GSM_ERR_NONE);
}

GSM_Error GSM_Phone_N6510::GetSMSFolderStatus1(GSM_SMS_Loc *SMSLocations)
{
	unsigned char Buff[] = {NOKIA_FRAME1, 0x0C,
				0x01,		// 0x01=SIM, 0x02=ME
				0x00,		// folder ID
				0x0F, 0x55, 0x55, 0x55};

	switch (SMSLocations->FolderID) {
	case 0x01: // SIM Inbox
		Buff[5] = 0x02;
		break;
	case 0x02: // SIM Outbox
		Buff[5] = 0x03;
		break;
	default: // ME
		Buff[4] = 0x02;
		Buff[5] = SMSLocations->FolderID - 1;
	}

	(*Debug)->Deb("SENT: getting SMS folder status\n");
	return Write(Buff, sizeof(Buff), 0x14, 4, ID_GetSMSFolderStatus+ID, SMSLocations);
}

GSM_Error GSM_Phone_N6510::ReplyGetSMS1(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	GSM_SMSList 	*List = (GSM_SMSList *)S;
	GSM_SMSEntry 	SMS;
	GSM_Error	error;

	switch (msg->Buffer.data()[3]) {
	case 0x03:
		(*Debug)->Deb("RECEIVED: SMS message\n");
		switch (msg->Buffer.data()[5]) {
			case  1 : List->Icon = SMS_Read;   break;
			case  3 : List->Icon = SMS_UnRead; break;
			case  5 : List->Icon = SMS_Sent;   break;
			case  7 : List->Icon = SMS_UnSent; break;
			default : return GSM_Return_Error(GSM_ERR_FRAME_CONTENT_UNKNOWN);
		}
		List->SaveDateTimeAvailable = FALSE;
		switch (msg->Buffer.data()[14]) {
		case 0x00:
		case 0x01:
		case 0x02:
			List->SaveDateTime.Year = 0;
			error = DecodeSMSFrame1(&SMS,msg->Buffer.data()+16,msg->Buffer.size()-16,&List->SaveDateTime);
			if (error.Code == GSM_ERR_NONE) {
				if (List->SaveDateTime.Year != 0) List->SaveDateTimeAvailable = TRUE;
				List->ClearAll();
				List->Add(&SMS);
			}
			return error;
		case 0xA0: // Picture message
			List->ClearAll();
		        return GSM_Return_Error(GSM_ERR_NONE);
		}
		return GSM_Return_Error(GSM_ERR_FRAME_CONTENT_UNKNOWN);
	case 0x0F:
		(*Debug)->Deb("RECEIVED: name for SMS message\n");
		List->SetName(NokiaGetUnicodeString(msg->Buffer.data()+52));
	        return GSM_Return_Error(GSM_ERR_NONE);
	}
	return GSM_Return_Error(GSM_ERR_FRAME_CONTENT_UNKNOWN);
}

GSM_Error GSM_Phone_N6510::GetSMS1(GSM_SMSList *List)
{
	GSM_Error		error;
	unsigned char		FolderID;
	int			Location;
	unsigned char 		Buff[] = {NOKIA_FRAME1, 0x02,
					  0x01,		// 0x01=SIM, 0x02=ME
					  0x00,		// folder ID
					  0x00, 0x00,	// location
					  0x01, 0x00};

	error = GetSMSLocation(List, &FolderID, &Location);
	if (error.Code != GSM_ERR_NONE) return error;

	List->Folder2 = FolderID;
	List->Memory  = MEM_SIM;

	switch (FolderID) {
	case 0x01: // SIM Inbox
		Buff[5] = 0x02;
		break;
	case 0x02: // SIM Outbox
		Buff[5] = 0x03;
		break;
	default: // ME
		List->Memory 	= MEM_PHONE;
		Buff[4] 	= 0x02;
		Buff[5] 	= FolderID - 1;
	}

	Buff[6]=Location / 256;
	Buff[7]=Location % 256;

	(*Debug)->Deb("SENT: getting SMS message\n");
	error = Write(Buff, sizeof(Buff), 0x14, 4, ID_GetSMS+ID, List);
	if (error.Code!=GSM_ERR_NONE) return error;

	Buff[3] = 0x0e; Buff[8] = 0x55; Buff[9] = 0x55;
	(*Debug)->Deb("SENT: getting SMS message name\n");
	return Write(Buff, sizeof(Buff), 0x14, 4, ID_GetSMS+ID, List);
}

GSM_Error GSM_Phone_N6510::GetNextSMS1(GSM_SMSList *List, BOOLEAN start)
{
	unsigned char		FolderID;
	int			Location;
	GSM_Error		error;
	unsigned int		i;
	bool			findnextfolder = TRUE;
	GSM_SMSFolders 		Folders;
	GSM_SMSFoldersSubEntry  *SubEntry;

	if (start == TRUE) {
		FolderID 	= 0x00;
		SMSFoldersNum 	= 0;
		SubEntry 	= NULL;
		error = GetSMSFolders(&Folders);
		if (error.Code!=GSM_ERR_NONE) return error;
		while (Folders.GetNext(&SubEntry) == TRUE) SMSFoldersNum++;
	} else {
		error = GetSMSLocation(List, &FolderID, &Location);
		if (error.Code != GSM_ERR_NONE) return error;

		for (i=0;i<SMSLocations.Locations.size();i++) {
			if (SMSLocations.Locations.data()[i]==Location) break;
		}
		if (i<SMSLocations.Locations.size()-1) {
			Location=SMSLocations.Locations.data()[i+1];
			findnextfolder=FALSE;
		}
	}
	if (findnextfolder==TRUE) {
		SMSLocations.Locations.clear();
		while (SMSLocations.Locations.size()==0) {
			FolderID++;

			/* Too high folder number */
			if ((FolderID-1)>=SMSFoldersNum) return GSM_Return_Error(GSM_ERR_EMPTY);

			/* Get next folder status */
			SMSLocations.FolderID = FolderID;
			error = GetSMSFolderStatus1(&SMSLocations);
			if (error.Code != GSM_ERR_NONE) return error;

			/* First location from this folder */
			Location=SMSLocations.Locations.data()[0];
		}
	}
	SetSMSLocation(List, FolderID, Location);

	return GetSMS1(List);
}

GSM_Error GSM_Phone_N6510::DecodeSMSFrame1(GSM_SMSEntry *SMS, const unsigned char *buffer, int len, GSM_DateTime *SaveDateTime)
{
	int current,num,i;
	
	SMS->PhoneNumber.clear();
	SMS->SMSCNumber.clear();
	SMS->UserData.clear();

	SMS->firstbyte = buffer[0];

	switch (SMS->GetType()) {
	case SMS_Deliver:
		SMS->TPPID   = buffer[1];
		SMS->TPDCS   = buffer[2];
		memcpy(SMS->DateTime,buffer+3,7);
		current = 14;
		break;
	case SMS_Submit:
		SMS->TPMR    = buffer[1];
		SMS->TPPID   = buffer[2];
		SMS->TPDCS   = buffer[3];
		//no TPVP
		current = 6;
		break;
	case SMS_Report:
		SMS->TPMR     = buffer[1];
		SMS->TPStatus = buffer[2];
		memcpy(SMS->DateTime,buffer+3,7);
		memcpy(SMS->SMSCTime,buffer+10,7);
		current = 18;
	}

	num = buffer[current-1];
	for (i=0;i<num;i++) {
		switch (buffer[current]) {
		case 0x80:
			(*Debug)->Deb("SMS text\n");
			if (buffer[current + 2] > buffer[current + 3]) {
				SMS->TPUDL = buffer[current+2];
			} else {
				SMS->TPUDL = buffer[current+3];
			}
			SMS->UserData.append(buffer+current+4,buffer[current+1]-4);
			break;
		case 0x82:
			switch (buffer[current+2]) {
			case 0x01:
				(*Debug)->Deb("phone number\n");
				SMS->PhoneNumber.append(buffer+current+4,buffer[current+4]+1);
				break;
			case 0x02:
				(*Debug)->Deb("SMSC number\n");
				SMS->SMSCNumber.append(buffer+current+4,buffer[current+4]+1);
				break;
			default:
				(*Debug)->Deb("unknown number\n");
				break;
			}
			break;
		case 0x84:
			(*Debug)->Deb("Date and time of saving for SMS template\n");
			if (SaveDateTime!=NULL) {
				if (SMS->PhoneNumber.size()>1 || SMS->SMSCNumber.size()>1) {
					SMS->SetType(SMS_Deliver);
					SMS->SetDateTime(NokiaGetDT(buffer+current+2));
				} else {
					memcpy(SaveDateTime,NokiaGetDT(buffer+current+2),sizeof(GSM_DateTime));
				}
			} else {
				return GSM_Return_Error(GSM_ERR_UNKNOWN);
			}
			break;
		default:
			(*Debug)->Deb("unknown block\n");
		}
		current += buffer[current+1];
	}
	return GSM_Return_Error(GSM_ERR_NONE);
}

GSM_Error GSM_Phone_N6510::EncodeSMSFrameToBuffer1(GSM_SMSEntry *SMS, unsignedstring *Buffer)
{
	unsignedstring 	Temp,Temp2;
	int 		num=0;
	unsigned char 	type,subtype;

	switch (SMS->GetType()) {
	case SMS_Deliver:
		Temp.push_back(SMS->TPPID);
		Temp.push_back(SMS->TPDCS);
		Temp.append(SMS->DateTime,7);
		Temp.push_back(0x55);
		Temp.push_back(0x55);
		Temp.push_back(0x55);
		Temp.push_back(0x03);//blocks number
		break;
	case SMS_Submit:
		Temp.push_back(SMS->TPMR);
		Temp.push_back(SMS->TPPID);
		Temp.push_back(SMS->TPDCS);
		Temp.push_back(0x00);
		Temp.push_back(0x04);//blocks number
		break;
	case SMS_Report:
		return GSM_Return_Error(GSM_ERR_NOT_SUPPORTED);
	}

	//phone numbers, validity
	while (true) {
		Temp2.clear();
		switch (num) {
		case 0x01:
			type = 0x82;
			subtype = 0x02;
			Temp2.push_back(SMS->SMSCNumber.size());
			Temp2.append(SMS->SMSCNumber.data(),SMS->SMSCNumber.size());
			break;
		case 0x00:
			type = 0x82;
			subtype = 0x01;
			Temp2.push_back(SMS->PhoneNumber.size());
			Temp2.append(SMS->PhoneNumber.data(),SMS->PhoneNumber.size());
			break;
		case 0x02:
			if (SMS->GetType()==SMS_Submit) {
				type = 0x08;
				subtype = 0x01;
				Temp2.push_back(SMS->TPVP);
			}
		}
		if (Temp2.size()!=0) {
			Temp.push_back(type);
			Temp.push_back(Temp2.size()+3);
			Temp.push_back(subtype);
			Temp.append(Temp2.data(),Temp2.size());
		}
		if (num == 0x02) break;
		num++;
	}

	//text
	Temp2.clear();
	Temp2.push_back(SMS->UserData.size());
	Temp2.push_back(SMS->TPUDL);
	Temp2.append(SMS->UserData.data(),SMS->UserData.size());
	Temp.push_back(0x80);
	Temp.push_back(Temp2.size()+4);
	Temp.append(Temp2.data(),Temp2.size());

	Buffer->push_back(0x01);
	switch (SMS->GetType()) {
		case SMS_Deliver: Buffer->push_back(0x00); break;
		case SMS_Submit : Buffer->push_back(0x02); break;
		case SMS_Report : 			   break;
	}
	Buffer->push_back(Temp.size()+3);
	Buffer->push_back(SMS->firstbyte);
	Buffer->append(Temp.data(),Temp.size());

	return GSM_Return_Error(GSM_ERR_NONE);	
}

GSM_Error GSM_Phone_N6510::ReplySetSMS1(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	unsigned char 		folder;
	GSM_SMSList 		*List = (GSM_SMSList *)S;

	switch (msg->Buffer.data()[3]) {
	case 0x01:
		if (msg->Buffer.data()[4]!=0x00) return GSM_Return_Error(GSM_ERR_FRAME_CONTENT_UNKNOWN);

		folder = msg->Buffer.data()[8] + 1;
		List->Memory = MEM_PHONE;
		//inbox,outbox
		if (msg->Buffer.data()[8] == 0x02 || msg->Buffer.data()[8] == 0x03) {
			if (msg->Buffer.data()[5] == 0x01) {
				folder = msg->Buffer.data()[8] - 1;
				List->Memory = MEM_SIM;
			}
		}
		//it's required to fill our structures after adding
		SetSMSLocation(List, folder, msg->Buffer.data()[6]*256+msg->Buffer.data()[7]);
		List->Folder2 = folder;
		return GSM_Return_Error(GSM_ERR_NONE);
	}
	return GSM_Return_Error(GSM_ERR_FRAME_CONTENT_UNKNOWN);
}

GSM_Error GSM_Phone_N6510::SetSMS1(GSM_SMSList *List)
{
	GSM_Error 		error;
	unsignedstring  	Buffer;
	GSM_SMSListSubEntry 	*SMS = NULL;
	BOOLEAN 		result;
	unsigned char		FolderID;
	int			Location;

	//1 sms only
	result = List->GetNext(&SMS);
	if (result == FALSE) return GSM_Return_Error(GSM_ERR_NOT_SUPPORTED);

	if (SMS->GetSMS()->GetType()==SMS_Report) return GSM_Return_Error(GSM_ERR_NOT_SUPPORTED);

	Buffer.push_back(0x00);
	Buffer.push_back(0x01);
	Buffer.push_back(0x00);
	Buffer.push_back(0x00);

	if (List->ID2.length()==0) {
		//for adding sms to folder
		FolderID = List->Folder2;
		Location = 0;
	} else {
		error = GetSMSLocation(List, &FolderID, &Location);
		if (error.Code != GSM_ERR_NONE) return error;
	}
	switch (FolderID) {
	case 0x01: // SIM Inbox
	case 0x02: // SIM Outbox
		Buffer.push_back(0x01); //SIM
		Buffer.push_back(FolderID + 1); //folder ID
		break;
	default:
		Buffer.push_back(0x02); //ME
		Buffer.push_back(FolderID - 1); //folder ID
	}
	Buffer.push_back(Location/256);
	Buffer.push_back(Location%256);

	switch (SMS->GetSMS()->GetType()) {
	case SMS_Deliver:
		switch (List->Icon) {
			case SMS_Sent	: // we use GSM_Read, because phone return error
			case SMS_Read	: Buffer.push_back(0x01); break;
			case SMS_UnSent	: // we use GSM_UnRead, because phone return error
			case SMS_UnRead	: Buffer.push_back(0x03); break;
		}
		break;
	case SMS_Submit:
		switch (List->Icon) {
			case SMS_Sent	: // we use GSM_Sent, because phone change folder
			case SMS_Read	: Buffer.push_back(0x05); break;
			case SMS_UnSent	: // we use GSM_UnSent, because phone change folder
			case SMS_UnRead	: Buffer.push_back(0x07); break;
		}
	default:
		break;
	}

	error = EncodeSMSFrameToBuffer1(SMS->GetSMS(), &Buffer);
	if (error.Code != GSM_ERR_NONE) return error;

	(*Debug)->Deb("SENT: Adding SMS\n");
	error = Write((unsigned char *)Buffer.data(), Buffer.size(), 0x14, 4, ID_SetSMS+ID,List);
	if (error.Code != GSM_ERR_NONE) return error;

	if (FolderID<3 || UnicodeLength(List->GetName()) == 0) return GSM_Return_Error(GSM_ERR_NONE);

	error = GetSMSLocation(List, &FolderID, &Location);
	if (error.Code != GSM_ERR_NONE) return error;

	Buffer.clear();
	Buffer.push_back(0x00);
	Buffer.push_back(0x01);
	Buffer.push_back(0x00);
	Buffer.push_back(0x16);
	switch (FolderID) {
	case 0x01: // SIM Inbox
	case 0x02: // SIM Outbox
		Buffer.push_back(0x01); //SIM
		Buffer.push_back(FolderID + 1); //folder ID
		break;
	default:
		Buffer.push_back(0x02); //ME
		Buffer.push_back(FolderID - 1); //folder ID
	}
	Buffer.push_back(Location/256);
	Buffer.push_back(Location%256);
	NokiaSetUnicodeString(List->GetName(),&Buffer);
	Buffer.push_back(0x00);
	Buffer.push_back(0x00);

	(*Debug)->Deb("SENT: Setting SMS name\n");
	return Write((unsigned char *)Buffer.data(), Buffer.size(), 0x14, 4, ID_SetSMSName+ID,List);
}

GSM_Error GSM_Phone_N6510::ReplyDeleteSMS1(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	GSM_SMSList *List = (GSM_SMSList *)S;

	switch (msg->Buffer.data()[3]) {
	case 0x05:
		(*Debug)->Deb("SMS deleted\n");
		return GSM_Return_Error(GSM_ERR_NONE);
	case 0x06:
		(*Debug)->Deb("SMS not deleted\n");
	}
	return GSM_Return_Error(GSM_ERR_UNKNOWN);
}

GSM_Error GSM_Phone_N6510::DeleteSMS1(GSM_SMSList *List)
{
	unsignedstring  	Buffer;
	GSM_SMSListSubEntry 	*SMS = NULL;
	unsigned char		FolderID;
	int			Location;
	GSM_Error		error;

	Buffer.push_back(0x00);
	Buffer.push_back(0x01);
	Buffer.push_back(0x00);
	Buffer.push_back(0x04);

	error = GetSMSLocation(List, &FolderID, &Location);
	if (error.Code != GSM_ERR_NONE) return error;

	switch (FolderID) {
	case 0x01: // SIM Inbox
	case 0x02: // SIM Outbox
		Buffer.push_back(0x01); //SIM
		Buffer.push_back(FolderID + 1); //folder ID
		break;
	default:
		Buffer.push_back(0x02); //ME
		Buffer.push_back(FolderID - 1); //folder ID
	}
	Buffer.push_back(Location/256);
	Buffer.push_back(Location%256);

	Buffer.push_back(0x0F);
	Buffer.push_back(0x55);

	(*Debug)->Deb("SENT: deleting SMS\n");
	return Write((unsigned char *)Buffer.data(), Buffer.size(), 0x14, 4, ID_DelSMS+ID,List);
}

/* -------------------------------- shared --------------------------------- */

GSM_Error GSM_Phone_N6510::ReplyGetSMSC(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	GSM_SMSC 	*SMSC = (GSM_SMSC *)S;
	int		i, current = 14;
	wchar_t		Buff[50];
	GSM_Error	error;

	(*Debug)->Deb("RECEIVED: SMSC\n");

	switch (msg->Buffer.data()[4]) {
		case 0x00:	break;
		case 0x02:	return GSM_Return_Error(GSM_ERR_INVALID_LOCATION);
		default  :	return GSM_Return_Error(GSM_ERR_UNKNOWN);
	}

	switch (msg->Buffer.data()[10]) {
		case 0x00: SMSC->Format = SMS_Text; 	break;
		case 0x22: SMSC->Format = SMS_Fax; 	break;
		case 0x26: SMSC->Format = SMS_Pager;	break;
		case 0x32: SMSC->Format = SMS_Email;	break;
		default  : SMSC->Format = SMS_Text;
	}

	SMSC->RelativeValidity = msg->Buffer.data()[12];
	if (msg->Buffer.data()[12] == 0x00) SMSC->RelativeValidity = SMS_RelativeValidity_Max_Time;

	Buff[0] = 0;
	SMSC->SetDefaultNumber(Buff);
	SMSC->SetSMSCNumber(Buff);
	SMSC->SetName(Buff);

	for (i=0;i<msg->Buffer.data()[13];i++) {
		switch (msg->Buffer.data()[current]) {
		case 0x81:
			SMSC->SetName(NokiaGetUnicodeString(msg->Buffer.data()+current+4));
			(*Debug)->Deb("  Name %s\n",UnicodeToStringReturn(SMSC->GetName()));
			break;
		case 0x82:
			switch (msg->Buffer.data()[current+2]) {
			case 0x01:
				error = GSM_DecodeSMSNumber(Buff, msg->Buffer.data()+current+4, msg->Buffer.data()[current+3], TRUE);
				if (error.Code != GSM_ERR_NONE) return error;
				SMSC->SetDefaultNumber(Buff);
				(*Debug)->Deb("  Default number %s\n",UnicodeToStringReturn(SMSC->GetDefaultNumber()));
				break;
			case 0x02:
				error = GSM_DecodeSMSNumber(Buff, msg->Buffer.data()+current+4, msg->Buffer.data()[current+3], FALSE);
				if (error.Code != GSM_ERR_NONE) return error;
				SMSC->SetSMSCNumber(Buff);
				(*Debug)->Deb("  Number %s\n",UnicodeToStringReturn(SMSC->GetSMSCNumber()));
				break;
			default:
				(*Debug)->Deb("RECEIVED: unknown number\n");
				return GSM_Return_Error(GSM_ERR_FRAME_CONTENT_UNKNOWN);
			}
			break;
		default:
			(*Debug)->Deb("RECEIVED: unknown block\n");
			return GSM_Return_Error(GSM_ERR_FRAME_CONTENT_UNKNOWN);
		}
		current += msg->Buffer.data()[current+1];
	}

	return GSM_Return_Error(GSM_ERR_NONE);
}

GSM_Error GSM_Phone_N6510::GetSMSC(GSM_SMSC *SMSC)
{
	unsigned char Buff[] = {NOKIA_FRAME1, 0x14,
				0x00,			// location
				0x00};

	if (SMSC->Location == 0 || SMSC->Location > 255) {
		return GSM_Return_Error(GSM_ERR_INVALID_LOCATION);
	}
	
	Buff[4] = SMSC->Location;
	
	(*Debug)->Deb("SENT: getting SMSC\n");
	return Write(Buff, sizeof(Buff), 0x02, 4, ID_GetSMSC+ID, SMSC); 
}

GSM_Error GSM_Phone_N6510::ReplySendSMS(GSM_Protocol_Message *msg, DebugInfo **Debug, unsigned char *S)
{
	switch (msg->Buffer.data()[8]) {
	case 0x00:
		if (SMSSendReply != NULL) SMSSendReply(msg->Buffer.data()[10]);
		return GSM_Return_Error(GSM_ERR_NONE);
	default:
		if (SMSSendReply != NULL) SMSSendReply(-1);
		return GSM_Return_Error(GSM_ERR_NONE);
	}
}

GSM_Error GSM_Phone_N6510::SendSMS(GSM_SMSEntry *SMS)
{
	GSM_Error 		error;
	unsignedstring  	Buffer;

	if (SMS->GetType()!=SMS_Submit) return GSM_Return_Error(GSM_ERR_NOT_SUPPORTED);

	Buffer.push_back(0x00);
	Buffer.push_back(0x01);
	Buffer.push_back(0x00);
	Buffer.push_back(0x02);
	Buffer.push_back(0x00);
	Buffer.push_back(0x00);
	Buffer.push_back(0x00);
	Buffer.push_back(0x55);
	Buffer.push_back(0x55);

	error = EncodeSMSFrameToBuffer1(SMS, &Buffer);
	if (error.Code != GSM_ERR_NONE) return error;

	(*Debug)->Deb("SENT: Sending SMS\n");
	return (*Protocols)->Current->Write((unsigned char *)Buffer.data(), Buffer.size(), 0x02);
}

GSM_Error GSM_Phone_N6510::GetNextSMS(GSM_SMSList *List, BOOLEAN start)
{
	if ((*Phones)->Feature("s40_30")==TRUE) return GetNextSMS2(List,start);
	return GetNextSMS1(List,start);
}

GSM_Error GSM_Phone_N6510::GetSMSStatus(GSM_SMSStatus *Status)
{
	if ((*Phones)->Feature("s40_30")==TRUE) return GSM_Return_Error(GSM_ERR_NOT_SUPPORTED);
	return GetSMSStatus1(Status);
}

GSM_Error GSM_Phone_N6510::GetSMSFolders(GSM_SMSFolders *Folders)
{
	if ((*Phones)->Feature("s40_30")==TRUE) return GetSMSFolders2(Folders);
	return GetSMSFolders1(Folders);
}

GSM_Error GSM_Phone_N6510::SetSMS(GSM_SMSList *List)
{
	if ((*Phones)->Feature("s40_30")==TRUE) return GSM_Return_Error(GSM_ERR_NOT_SUPPORTED);
	return SetSMS1(List);
}

GSM_Error GSM_Phone_N6510::DeleteSMS(GSM_SMSList *List)
{
	if ((*Phones)->Feature("s40_30")==TRUE) return DeleteSMS2(List);
	return DeleteSMS1(List);
}
